# TrackTor

TrackTor is a platform independent tool that provides statistical and analytical data tracked from the tor services exercised by the end user. Some of the highlighting features of TrackTor include detailed Bandwidth, Connections and Resources usage information, Event Logs details and many more. TrackTor finds its significance and wide usage with respect to professional commercial and research work ongoing in the field of Deep/Dark web. It is an enhanced and versatile Graphical User Interface (GUI) based implementation, providing it an edge over the previously existing contemporary monitoring tools.

## TrackTor Features

**General Features**

  1. Graphical User Interface
  2. Platform Independent
  3. User Friendly

**Utilities**

  4. Relay Information
  5. Node Information
  6. Bandwidth Graph (Uploads & Downloads Data)
  7. Connections Graph (Inbound & Outbound Connections)
  8. Resources Graph (CPU & RAM Usage)
  9. Logging of Events and Option to Save Selected Log Information
  10. New Identity Creation
  11. Edit and Configure Torrc (Tor's Configuration File)
  12. Setting Configurations
  13. Connect/ Disconnect Tor

**Features in Detail**

  14. Detailed Connections Information
  15. Detailed Resources Information

## Technologies Used in Development

1. Frontend (GUI) - PyQT5, Pyqtgraph

2. Backend - Python3, Stem API

   **Python Modules & Libraries Used**

      1.  psutil,
      2.  getpass
      3.  sqlite3
      4.  threading
      5.  numpy
      6.  collections
      7.  functools
      8.  argparse
      9.  pycountry
      10. time, datetime, Calendar

## Getting Started with TrackTor

  Step 1 : Download and Setup Python on System (Python3+ Recommended)

  Step 2 : Download Tor Browser from https://www.torproject.org/download/languages/. It is the easiest and most common method to exercise TOR Network.

  Step 3 : Copy the following command and run it in your native Terminal (CMD for Windows), Replace 'x' with your pip version (pip/pip3),

  ```
  $ pipx install TrackTor
  ```

  Step 4 : Open/Run Tor Browser

  Step 5 : Type and Run the following on Terminal,

  ```
  $ TrackTor
  ```

  Step 6 : Hurray! You have successfully setup TrackTor on your system.

## About the Developers

Institute : Malaviya National Institute of Technology

Department : Computer Science & Engineering

Developers,

  1. Harsh Gandhi   - hrgandhi1@gmail.com
  2. Ritu Karela    - ritukarela1234@gmail.com
  3. Parul Agrawal  - parulagrawal1507@gmail.com

Mentor : Dr. Pilli Emmanuel Shubhakar - espilli.cse@mnit.ac.in
